package be.iminds.ilabt.jfed.highlevel.tasks;

import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.controller.TaskExecution;
import be.iminds.ilabt.jfed.lowlevel.connection.JFedException;
import be.iminds.ilabt.jfed.lowlevel.api_wrapper.UserAndSliceApiWrapper;
import be.iminds.ilabt.jfed.util.common.GeniUrn;
import be.iminds.ilabt.jfed.highlevel.util.JavaFXLogger;

import javax.annotation.Nonnull;
import java.util.Collections;
import java.util.List;

/**
 * User: twalcari
 * Date: 7/29/2015
 * Time: 11:02
 */
public class ListSubAuthorityMembersTask extends Task {

    @Nonnull private final String projectName;
    @Nonnull private final UserAndSliceApiWrapper userAndSliceApiWrapper;
    @Nonnull private final JavaFXLogger logger;

    private List<GeniUrn> memberUrns;

    public ListSubAuthorityMembersTask(@Nonnull String projectName,
                                       @Nonnull UserAndSliceApiWrapper userAndSliceApiWrapper,
                                       @Nonnull JavaFXLogger logger) {
        super("List members of " + projectName);
        this.projectName = projectName;
        this.userAndSliceApiWrapper = userAndSliceApiWrapper;
        this.logger = logger;
    }


    @Override
    protected void doTask(@Nonnull TaskExecution taskExecution) throws JFedException, InterruptedException {
        memberUrns =
                userAndSliceApiWrapper.getUsersForSubAuthority(JavaFXLogger.wrap(logger, taskExecution), projectName);
    }

    @Nonnull
    public List<GeniUrn> getMemberUrns() {
        return memberUrns == null ?
                Collections.emptyList() :
                Collections.unmodifiableList(memberUrns);
    }
}
